﻿using System;
using System.Data;

using System.Transactions;
using System.Data.SqlClient;

public class Class2
{
    private string strConnString = System.Configuration.ConfigurationManager.ConnectionStrings["Conn_Northwind"].ToString();

    public Class2()
    {
    }

    public string func2(int intTheNewestID)
    {
        SqlConnection conn = null;
        SqlCommand cmd1 = null;
        SqlCommand cmd2 = null;
        int intInserted = 0;
        string strReturn = "";
        string strSql1 = "INSERT INTO Employees (LastName, FirstName) VALUES('Lee', 'David')";
        string strSql2 = "SELECT LastName FROM Employees WHERE EmployeeID=" + intTheNewestID;

        //Required 选项: 当前环境若无事务，则创建新事务，否则就加入当前环境的同一个事务。在此例中，会启动 DTC，第二句 Select 会成功。
        //RequiresNew 选项: 总是创建新的事务，会造成 Class1、Class2 不会处于同一个事务里。在此例中，不会启动 DTC，第二句 Select 会失败。
        //Suppress 选项: 不加入此一事务。
        using (TransactionScope scope = new TransactionScope(TransactionScopeOption.Required))
        {
            try
            {
                conn = new SqlConnection(strConnString);
                conn.Open();
                if (conn.State == ConnectionState.Open)
                {
                    cmd1 = new SqlCommand(strSql1, conn);
                    intInserted = cmd1.ExecuteNonQuery();

                    //取得组件一里，刚刚才插入的那一笔记录，以确认组件一、组件二确实是在同一个事务中执行，而不是拆分成两个事务
                    cmd2 = new SqlCommand(strSql2, conn);
                    strReturn = cmd2.ExecuteScalar().ToString();

                    scope.Complete();
                }
            }
            catch (Exception ex)
            {
                throw new Exception("组件二 - 数据库访问发生错误: " + ex.ToString());
            }
            finally
            {
                if (cmd1 != null)
                    cmd1.Dispose();
                if (cmd2 != null)
                    cmd2.Dispose();
                if (conn.State == ConnectionState.Open)
                {
                    conn.Close();
                }
                conn.Dispose();
            }
        }

        return strReturn;    //返回组件一
    }

}

/*
 
示例二中，Class 2 里的 SELECT 语句，是故意要测试 Class1、Class2 是否包成同一个事务。

Class1 --- Required (insert)
Class2 --- Required (insert、select)
双方会在同一个事务

Class1 --- Required (insert)
Class2 --- RequiresNew (insert、select)
双方不在同一个事务，select 会撷取不到、引发连接逾时错误

但在实际的项目中，不应将 select 纳入事务。

*/